Attribute VB_Name = "modHandleText"
Option Explicit
Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDeviceCaps Lib "GDI32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function CreateRectRgn Lib "GDI32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long
Public Sub HandleText(ByRef oRTB As RichTextBox, ByRef oElem As MSXML.IXMLDOMElement, ByVal bThumb As Boolean, ByVal Zoom As Single)
10:  On Error GoTo Error_Handler
20:  If bThumb Then 'Don't show text because not accurate and PrintWindow ignores these texts mostly anyway...
30:  Else
40:    Dim sText       As String  'Contains the text to display
50:    Dim iResolution As Integer 'Monitor resolution (normally 96dpi)
60:    sText = GetSoftReturnTags(XMLToString(oElem.Text))
70:    iResolution = GetDeviceCaps(GetDC(0), LOGPIXELSX)
80:    If frmPixbook.TabStrip1.SelectedItem.Key = "tab1" Or (frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) <= 2) Then
90:      frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw
100:      frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oElem.getAttribute("HEIGHT") / iPgHtTw
110:    ElseIf frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
120:      frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oElem.getAttribute("WIDTH") / iCvrWdTw
130:      frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oElem.getAttribute("HEIGHT") / iCvrHtTw
140:    ElseIf frmPixbook.TabStrip1.SelectedItem.Key = "tab2" Then
150:      If iPgWd <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oRTB.Width / iPgWd / Zoom
160:      If iPgHt <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oRTB.Height / iPgHt / Zoom
170:    ElseIf CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
180:      If iPgWd <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oRTB.Width / iPgWd / Zoom
190:      If iPgHt <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oRTB.Height / iPgHt / Zoom
200:    End If
210:    frmAbout.RealSizeRTB.Text = sText
220:    If Len(oElem.getAttribute("SIZE")) >= 2 Then frmAbout.RealSizeRTB.Font.Size = Left(oElem.getAttribute("SIZE"), Len(oElem.getAttribute("SIZE")) - 2)
230:    oRTB.Visible = False
240:    oRTB.Text = sText
250:    oRTB.Tag = oElem.getAttribute("HALIGN") & "|" & oElem.getAttribute("ROTATION") & "#" & sText
260:    On Error Resume Next
270:    oRTB.Font.Name = oElem.getAttribute("FONT")
280:    On Error GoTo Error_Handler
290:    oRTB.Font.Size = frmAbout.RealSizeRTB.Font.Size * oRTB.Width / frmAbout.RealSizeRTB.Width
300:    oRTB.Font.Size = oRTB.Font.Size + 2 * 72 / iResolution 'Start with largest font possible, then reduce font size if necessary
310:    If oElem.getAttribute("EMPH") = "BOLDITALIC" Then
320:      oRTB.Font.Bold = True
330:      oRTB.Font.Italic = True
340:    ElseIf oElem.getAttribute("EMPH") = "BOLD" Then
350:      oRTB.Font.Bold = True
360:      oRTB.Font.Italic = False
370:    ElseIf oElem.getAttribute("EMPH") = "ITALIC" Then
380:      oRTB.Font.Bold = False
390:      oRTB.Font.Italic = True
400:    Else
410:      oRTB.Font.Bold = False
420:      oRTB.Font.Italic = False
430:    End If
440:    oRTB.Font.Underline = oElem.getAttribute("UNDERLINE")
450:    frmAbout.RealSizeRTB.Font.Name = oRTB.Font.Name
460:    frmAbout.RealSizeRTB.Font.Bold = oRTB.Font.Bold
470:    frmAbout.RealSizeRTB.Font.Italic = oRTB.Font.Italic
480:    frmAbout.RealSizeRTB.Font.Underline = oRTB.Font.Underline
490:    Dim iPos As Integer
500:    Dim sTag As String
510:    For iPos = 1 To Len(frmAbout.RealSizeRTB.Text) - 1
520:      If frmAbout.RealSizeRTB.GetLineFromChar(iPos + 1) <> frmAbout.RealSizeRTB.GetLineFromChar(iPos) Then sTag = sTag & iPos + 1 & ","
530:    Next
540:    frmAbout.RealSizeRTB.Tag = sTag 'Exact positions of the soft returns
550:    Dim OriLines As Integer 'Real size RTB number of lines
560:    Dim OriChars As Integer 'Real size RTB number of chars on last line
570:    OriLines = frmAbout.RealSizeRTB.GetLineFromChar(Len(frmAbout.RealSizeRTB.Text))
580:    OriChars = GetNumberOfCharsOnLastLine(frmAbout.RealSizeRTB)
Retry:
590:    If oRTB.GetLineFromChar(Len(oRTB.Text)) > OriLines Or (oRTB.GetLineFromChar(Len(oRTB.Text)) = OriLines And GetNumberOfCharsOnLastLine(oRTB) > OriChars) Or SmallerSoftReturnPositions(oRTB) Then
600:      oRTB.Font.Size = oRTB.Font.Size - 72 / iResolution
610:      GoTo Retry
620:    End If
630:    Dim i As Integer
640:    Dim j As Integer
650:    sTag = frmAbout.RealSizeRTB.Tag
660:    Do While sTag <> vbNullString
670:      i = 0
680:      iPos = CInt(Left(sTag, InStr(sTag, ",") - 1)) + j
690:      Do While oRTB.GetLineFromChar(iPos - 1) = oRTB.GetLineFromChar(iPos + i)
700:        oRTB.Text = Left(oRTB.Text, iPos - 1) & " " & mid(oRTB.Text, iPos)
710:        i = i + 1
720:      Loop
730:      sTag = mid(sTag, InStr(sTag, ",") + 1)
740:      j = j + i
750:    Loop
760:    oRTB.SelStart = 0
770:    oRTB.SelLength = Len(oRTB.Text)
780:    oRTB.SelColor = RGB2VB(oElem.getAttribute("COLOR"))
790:    If oRTB.SelColor = vbWhite Then
800:      oRTB.BackColor = vbBlack
810:    Else
820:      oRTB.BackColor = vbWhite
830:    End If
840:    If oElem.getAttribute("HALIGN") = "LEFT" Then
850:      oRTB.SelAlignment = rtfLeft
860:    ElseIf oElem.getAttribute("HALIGN") = "RIGHT" Then
870:      oRTB.SelAlignment = rtfRight
880:    ElseIf oElem.getAttribute("HALIGN") = "CENTER" Then
890:      oRTB.SelAlignment = rtfCenter
900:    ElseIf oElem.getAttribute("HALIGN") = "JUSTIFY" Then
910:      SetAlignment oRTB.hWnd, ercParaJustify
920:    End If
930:    oRTB.SelLength = 0
940:    oRTB.Visible = True
950:    oRTB.ZOrder 0
960:  End If
970:  Exit Sub
Error_Handler:
  HandleError Err, "modHandleText:HandleText", Erl
980:  Resume Next
End Sub
Public Sub HandleRotatedText(ByRef oPic As PictureBox, ByRef oElem As MSXML.IXMLDOMElement, ByVal bThumb As Boolean, ByVal Zoom As Single)
990:  On Error GoTo Error_Handler
1000:  If bThumb Then 'Don't show text because not accurate and PrintWindow ignores these texts mostly anyway...
1010:  Else
1020:    Dim sText       As String  'Contains the text to display
1030:    Dim iResolution As Integer 'Monitor resolution (normally 96dpi)
1040:    sText = GetSoftReturnTags(XMLToString(oElem.Text))
1050:    iResolution = GetDeviceCaps(GetDC(0), LOGPIXELSX)
1060:    If frmPixbook.TabStrip1.SelectedItem.Key = "tab1" Or (frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) <= 2) Then
1070:      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
1080:        frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw
1090:        frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oElem.getAttribute("HEIGHT") / iPgHtTw
1100:      Else '+/-90 or +/-270
1110:        frmAbout.RealSizeRTB.Width = MM2TW * iPgHtMm * oElem.getAttribute("HEIGHT") / iPgHtTw
1120:        frmAbout.RealSizeRTB.Height = MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw
1130:      End If
1140:    ElseIf frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
1150:      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
1160:        frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oElem.getAttribute("WIDTH") / iCvrWdTw
1170:        frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oElem.getAttribute("HEIGHT") / iCvrHtTw
1180:      Else '+/-90 or +/-270
1190:        frmAbout.RealSizeRTB.Width = MM2TW * iCvrHtMm * oElem.getAttribute("HEIGHT") / iCvrHtTw
1200:        frmAbout.RealSizeRTB.Height = MM2TW * iCvrWdMm * oElem.getAttribute("WIDTH") / iCvrWdTw
1210:      End If
1220:    ElseIf frmPixbook.TabStrip1.SelectedItem.Key = "tab2" Then
1230:      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
1240:        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oPic.Width / iPgWd / Zoom
1250:        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oPic.Height / iPgHt / Zoom
1260:      Else '+/-90 or +/-270
1270:        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iPgHtMm * oPic.Height / iPgHt / Zoom
1280:        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iPgWdMm * oPic.Width / iPgWd / Zoom
1290:      End If
1300:    ElseIf CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
1310:      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
1320:        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oPic.Width / iPgWd / Zoom
1330:        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oPic.Height / iPgHt / Zoom
1340:      Else '+/-90 or +/-270
1350:        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iCvrHtMm * oPic.Height / iPgHt / Zoom
1360:        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iCvrWdMm * oPic.Width / iPgWd / Zoom
1370:      End If
1380:    End If
1390:    frmAbout.RealSizeRTB.Text = sText
1400:    If Len(oElem.getAttribute("SIZE")) >= 2 Then frmAbout.RealSizeRTB.Font.Size = Left(oElem.getAttribute("SIZE"), Len(oElem.getAttribute("SIZE")) - 2)
1410:    If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
1420:      frmAbout.RotatedRTB.Width = oPic.Width
1430:      frmAbout.RotatedRTB.Height = oPic.Height
1440:    Else '+/-90 or +/-270
1450:      frmAbout.RotatedRTB.Width = oPic.Height
1460:      frmAbout.RotatedRTB.Height = oPic.Width
1470:    End If
1480:    frmAbout.RotatedRTB.Text = sText
1490:    On Error Resume Next
1500:    frmAbout.RotatedRTB.Font.Name = oElem.getAttribute("FONT")
1510:    On Error GoTo Error_Handler
1520:    frmAbout.RotatedRTB.Font.Size = frmAbout.RealSizeRTB.Font.Size * frmAbout.RotatedRTB.Width / frmAbout.RealSizeRTB.Width
1530:    frmAbout.RotatedRTB.Font.Size = frmAbout.RotatedRTB.Font.Size + 2 * 72 / iResolution 'Start with largest font possible, then reduce font size if necessary
1540:    If oElem.getAttribute("EMPH") = "BOLDITALIC" Then
1550:      frmAbout.RotatedRTB.Font.Bold = True
1560:      frmAbout.RotatedRTB.Font.Italic = True
1570:    ElseIf oElem.getAttribute("EMPH") = "BOLD" Then
1580:      frmAbout.RotatedRTB.Font.Bold = True
1590:      frmAbout.RotatedRTB.Font.Italic = False
1600:    ElseIf oElem.getAttribute("EMPH") = "ITALIC" Then
1610:      frmAbout.RotatedRTB.Font.Bold = False
1620:      frmAbout.RotatedRTB.Font.Italic = True
1630:    Else
1640:      frmAbout.RotatedRTB.Font.Bold = False
1650:      frmAbout.RotatedRTB.Font.Italic = False
1660:    End If
1670:    frmAbout.RotatedRTB.Font.Underline = oElem.getAttribute("UNDERLINE")
1680:    frmAbout.RealSizeRTB.Font.Name = frmAbout.RotatedRTB.Font.Name
1690:    frmAbout.RealSizeRTB.Font.Bold = frmAbout.RotatedRTB.Font.Bold
1700:    frmAbout.RealSizeRTB.Font.Italic = frmAbout.RotatedRTB.Font.Italic
1710:    frmAbout.RealSizeRTB.Font.Underline = frmAbout.RotatedRTB.Font.Underline
1720:    Dim iPos As Integer
1730:    Dim sTag As String
1740:    For iPos = 1 To Len(frmAbout.RealSizeRTB.Text) - 1
1750:      If frmAbout.RealSizeRTB.GetLineFromChar(iPos + 1) <> frmAbout.RealSizeRTB.GetLineFromChar(iPos) Then sTag = sTag & iPos + 1 & ","
1760:    Next
1770:    frmAbout.RealSizeRTB.Tag = sTag 'Exact positions of the soft returns
1780:    Dim OriLines As Integer 'Real size RTB number of lines
1790:    Dim OriChars As Integer 'Real size RTB number of chars on last line
1800:    OriLines = frmAbout.RealSizeRTB.GetLineFromChar(Len(frmAbout.RealSizeRTB.Text))
1810:    OriChars = GetNumberOfCharsOnLastLine(frmAbout.RealSizeRTB)
Retry:
1820:    If frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text)) > OriLines Or (frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text)) = OriLines And GetNumberOfCharsOnLastLine(frmAbout.RotatedRTB) > OriChars) Or SmallerSoftReturnPositions(frmAbout.RotatedRTB) Then
1830:      frmAbout.RotatedRTB.Font.Size = frmAbout.RotatedRTB.Font.Size - 72 / iResolution
1840:      GoTo Retry
1850:    End If
1860:    Dim i As Integer
1870:    Dim j As Integer
1880:    sTag = frmAbout.RealSizeRTB.Tag
1890:    oPic.Tag = oElem.getAttribute("HALIGN") & "|" & oElem.getAttribute("ROTATION") & "#" & GetSoftReturnTags(XMLToString(oElem.Text))
1900:    oPic.FontName = frmAbout.RotatedRTB.Font.Name
1910:    oPic.fontSize = frmAbout.RotatedRTB.Font.Size
1920:    oPic.FontBold = frmAbout.RotatedRTB.Font.Bold
1930:    oPic.FontItalic = frmAbout.RotatedRTB.Font.Italic
1940:    oPic.FontUnderline = frmAbout.RotatedRTB.Font.Underline
1950:    oPic.ForeColor = RGB2VB(oElem.getAttribute("COLOR"))
1960:    If oPic.ForeColor = vbWhite Then
1970:      oPic.BackColor = vbBlack
1980:    Else
1990:      oPic.BackColor = vbWhite
2000:    End If
2010:    PrintRotatedText oPic, frmAbout.RotatedRTB.Text, oElem.getAttribute("ROTATION"), oElem.getAttribute("HALIGN")
2020:    oPic.Visible = True
2030:    oPic.ZOrder 0
2040:  End If
2050:  Exit Sub
Error_Handler:
  HandleError Err, "modHandleText:HandleRotatedText", Erl
2060:  Resume Next
End Sub
Public Function HandleResizedText(ByRef oRTB As RichTextBox) As Boolean
2070:  On Error GoTo Error_Handler
2080:  oRTB.Visible = False
2090:  oRTB.SelStart = 0
2100:  oRTB.SelLength = 1 '1 is enough, otherwise problems with soft/hard returns
2110:  frmAbout.picText.Font.Size = oRTB.SelFontSize
2120:  frmAbout.picText.Font.Name = oRTB.SelFontName
2130:  frmAbout.picText.Font.Bold = oRTB.SelBold
2140:  frmAbout.picText.Font.Italic = oRTB.SelItalic
2150:  frmAbout.picText.Font.Underline = oRTB.SelUnderline
2160:  Dim bLarger As Boolean
2170:  If frmPixbook.picDyn.ScaleWidth > oRTB.Width Or frmPixbook.picDyn.ScaleHeight > oRTB.Height Then bLarger = True '=> no limitations
2180:  If bLarger Or (frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY And frmAbout.picText.TextWidth(oRTB.SelText) <= frmPixbook.picDyn.ScaleWidth / iTwX) Then
2190:    Dim lPrevWidth  As Long
2200:    Dim lPrevHeight As Long
2210:    Dim hRegion     As Long
2220:    lPrevWidth = oRTB.Width
2230:    lPrevHeight = oRTB.Height
2240:    oRTB.Width = frmPixbook.picDyn.ScaleWidth
2250:    oRTB.Height = frmPixbook.picDyn.ScaleHeight
2260:    If bLarger Or frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY Then
2270:      hRegion = CreateRectRgn(0, 0, oRTB.Width / iTwX, oRTB.Height / iTwY)
2280:      SetWindowRgn oRTB.hWnd, hRegion, 1
2290:      DeleteObject hRegion
2300:      HandleResizedText = True
2310:    Else
2320:      oRTB.Width = lPrevWidth
2330:      oRTB.Height = lPrevHeight
2340:    End If
2350:  End If
2360:  oRTB.SelLength = 0
2370:  oRTB.Visible = True
2380:  Exit Function
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedText", Erl
2390:  Resume Next
End Function
Public Function HandleResizedTextFrame(ByRef oRTB As RichTextBox, ByRef oFrame As PictureBox) As Boolean
2400:  On Error GoTo Error_Handler
2410:  oRTB.Visible = False
2420:  oRTB.SelStart = 0
2430:  oRTB.SelLength = 1 '1 is enough, otherwise problems with soft/hard returns
2440:  frmAbout.picText.Font.Size = oRTB.SelFontSize
2450:  frmAbout.picText.Font.Name = oRTB.SelFontName
2460:  frmAbout.picText.Font.Bold = oRTB.SelBold
2470:  frmAbout.picText.Font.Italic = oRTB.SelItalic
2480:  frmAbout.picText.Font.Underline = oRTB.SelUnderline
2490:  Dim bLarger As Boolean
2500:  If frmPixbook.picDyn.ScaleWidth > oFrame.Width Or frmPixbook.picDyn.ScaleHeight > oFrame.Height Then bLarger = True '=> no limitations
2510:  If bLarger Or (frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY And frmAbout.picText.TextWidth(oRTB.SelText) <= frmPixbook.picDyn.ScaleWidth / iTwX) Then
2520:    Dim lPrevWidth  As Long
2530:    Dim lPrevHeight As Long
2540:    Dim hRegion     As Long
2550:    lPrevWidth = oRTB.Width
2560:    lPrevHeight = oRTB.Height
2570:    If oRTB.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width > 0 Then oRTB.Width = oRTB.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width
2580:    If oRTB.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height > 0 Then oRTB.Height = oRTB.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height
2590:    If bLarger Or frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY Then
2600:      hRegion = CreateRectRgn(0, 0, oRTB.Width / iTwX, oRTB.Height / iTwY)
2610:      SetWindowRgn oRTB.hWnd, hRegion, 1
2620:      DeleteObject hRegion
2630:      If oFrame.Tag = "0" Then SetWindowRgn oFrame.hWnd, 0, 1
2640:      HandleResizedTextFrame = True
2650:    Else
2660:      oRTB.Width = lPrevWidth
2670:      oRTB.Height = lPrevHeight
2680:    End If
2690:  End If
2700:  oRTB.SelLength = 0
2710:  oRTB.Visible = True
2720:  Exit Function
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedTextFrame", Erl
2730:  Resume Next
End Function
Public Function HandleResizedRotatedText(ByRef oPic As PictureBox) As Boolean
2740:  On Error GoTo Error_Handler
2750:  Dim lScaleWidth  As Long
2760:  Dim lScaleHeight As Long
2770:  If mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "180" Or mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "-180" Then
2780:    frmAbout.RotatedRTB.Width = oPic.Width
2790:    frmAbout.RotatedRTB.Height = oPic.Height
2800:    lScaleWidth = frmPixbook.picDyn.ScaleWidth
2810:    lScaleHeight = frmPixbook.picDyn.ScaleHeight
2820:  Else '+/-90 or +/-270
2830:    frmAbout.RotatedRTB.Width = oPic.Height
2840:    frmAbout.RotatedRTB.Height = oPic.Width
2850:    lScaleWidth = frmPixbook.picDyn.ScaleHeight
2860:    lScaleHeight = frmPixbook.picDyn.ScaleWidth
2870:  End If
2880:  frmAbout.RotatedRTB.Text = mid(oPic.Tag, InStr(oPic.Tag, "#") + 1)
2890:  frmAbout.RotatedRTB.SelStart = 0
2900:  frmAbout.RotatedRTB.SelLength = 1
2910:  frmAbout.RotatedRTB.Font.Size = oPic.Font.Size
2920:  frmAbout.RotatedRTB.Font.Name = oPic.Font.Name
2930:  frmAbout.RotatedRTB.Font.Bold = oPic.Font.Bold
2940:  frmAbout.RotatedRTB.Font.Italic = oPic.Font.Italic
2950:  frmAbout.RotatedRTB.Font.Underline = oPic.Font.Underline
2960:  Dim bLarger As Boolean
2970:  If frmPixbook.picDyn.ScaleWidth > oPic.Width Or frmPixbook.picDyn.ScaleHeight > oPic.Height Then bLarger = True '=> no limitations
2980:  If bLarger Or (oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY And oPic.TextWidth(frmAbout.RotatedRTB.SelText) <= lScaleWidth / iTwX) Then
2990:    Dim lPrevWidth  As Long
3000:    Dim lPrevHeight As Long
3010:    Dim hRegion     As Long
3020:    lPrevWidth = oPic.Width
3030:    lPrevHeight = oPic.Height
3040:    oPic.Width = frmPixbook.picDyn.ScaleWidth
3050:    oPic.Height = frmPixbook.picDyn.ScaleHeight
3060:    If bLarger Or oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY Then
3070:      hRegion = CreateRectRgn(0, 0, oPic.Width / iTwX, oPic.Height / iTwY)
3080:      SetWindowRgn oPic.hWnd, hRegion, 1
3090:      DeleteObject hRegion
3100:      HandleResizedRotatedText = True
3110:    Else
3120:      oPic.Width = lPrevWidth
3130:      oPic.Height = lPrevHeight
3140:    End If
3150:  End If
3160:  Exit Function
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedRotatedText", Erl
3170:  Resume Next
End Function
Public Function HandleResizedRotatedTextFrame(ByRef oPic As PictureBox, ByRef oFrame As PictureBox) As Boolean
3180:  On Error GoTo Error_Handler
3190:  Dim lScaleWidth  As Long
3200:  Dim lScaleHeight As Long
3210:  If mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "180" Or mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "-180" Then
3220:    frmAbout.RotatedRTB.Width = oPic.Width
3230:    frmAbout.RotatedRTB.Height = oPic.Height
3240:    lScaleWidth = frmPixbook.picDyn.ScaleWidth
3250:    lScaleHeight = frmPixbook.picDyn.ScaleHeight
3260:  Else '+/-90 or +/-270
3270:    frmAbout.RotatedRTB.Width = oPic.Height
3280:    frmAbout.RotatedRTB.Height = oPic.Width
3290:    lScaleWidth = frmPixbook.picDyn.ScaleHeight
3300:    lScaleHeight = frmPixbook.picDyn.ScaleWidth
3310:  End If
3320:  frmAbout.RotatedRTB.Text = mid(oPic.Tag, InStr(oPic.Tag, "#") + 1)
3330:  frmAbout.RotatedRTB.SelStart = 0
3340:  frmAbout.RotatedRTB.SelLength = 1
3350:  frmAbout.RotatedRTB.Font.Size = oPic.Font.Size
3360:  frmAbout.RotatedRTB.Font.Name = oPic.Font.Name
3370:  frmAbout.RotatedRTB.Font.Bold = oPic.Font.Bold
3380:  frmAbout.RotatedRTB.Font.Italic = oPic.Font.Italic
3390:  frmAbout.RotatedRTB.Font.Underline = oPic.Font.Underline
3400:  Dim bLarger As Boolean
3410:  If frmPixbook.picDyn.ScaleWidth > oFrame.Width Or frmPixbook.picDyn.ScaleHeight > oFrame.Height Then bLarger = True '=> no limitations
3420:  If bLarger Or (oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY And oPic.TextWidth(frmAbout.RotatedRTB.SelText) <= lScaleWidth / iTwX) Then
3430:    Dim lPrevWidth  As Long
3440:    Dim lPrevHeight As Long
3450:    Dim hRegion     As Long
3460:    lPrevWidth = oPic.Width
3470:    lPrevHeight = oPic.Height
3480:    If oPic.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width > 0 Then oPic.Width = oPic.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width
3490:    If oPic.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height > 0 Then oPic.Height = oPic.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height
3500:    If bLarger Or oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY Then
3510:      hRegion = CreateRectRgn(0, 0, oPic.Width / iTwX, oPic.Height / iTwY)
3520:      SetWindowRgn oPic.hWnd, hRegion, 1
3530:      DeleteObject hRegion
3540:      If oFrame.Tag = "0" Then SetWindowRgn oFrame.hWnd, 0, 1
3550:      HandleResizedRotatedTextFrame = True
3560:    Else
3570:      oPic.Width = lPrevWidth
3580:      oPic.Height = lPrevHeight
3590:    End If
3600:  End If
3610:  Exit Function
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedRotatedTextFrame", Erl
3620:  Resume Next
End Function
Private Function GetNumberOfCharsOnLastLine(ByRef RTB As RichTextBox) As Integer
3630:  On Error GoTo Error_Handler
3640:  Dim iPos As Integer 'Pointer position in RTB.Text
3650:  Dim iLns As Integer 'Number of lines in RTB.Text
3660:  iLns = RTB.GetLineFromChar(Len(RTB.Text))
3670:  For iPos = 1 To Len(RTB.Text)
3680:    If RTB.GetLineFromChar(iPos) = iLns Then GetNumberOfCharsOnLastLine = GetNumberOfCharsOnLastLine + 1
3690:  Next
3700:  Exit Function
Error_Handler:
  HandleError Err, "modHandleText:GetNumberOfCharsOnLastLine", Erl
3710:  Resume Next
End Function
Private Function SmallerSoftReturnPositions(ByRef RTB As RichTextBox) As Boolean
3720:  On Error GoTo Error_Handler
3730:  Dim sTag As String
3740:  Dim iPos As Integer
3750:  sTag = frmAbout.RealSizeRTB.Tag
3760:  For iPos = 1 To Len(RTB.Text) - 1
3770:    If RTB.GetLineFromChar(iPos + 1) <> RTB.GetLineFromChar(iPos) Then
3780:      If sTag = vbNullString Then
3790:        SmallerSoftReturnPositions = True
3800:        Exit For
3810:      End If
3820:      If CInt(Left(sTag, InStr(sTag, ",") - 1)) > iPos + 1 Then
3830:        SmallerSoftReturnPositions = True
3840:        Exit For
3850:      End If
3860:      sTag = mid(sTag, InStr(sTag, ",") + 1)
3870:    End If
3880:  Next
3890:  Exit Function
Error_Handler:
  HandleError Err, "modHandleText:SmallerSoftReturnPositions", Erl
3900:  Resume Next
End Function
